=== modified file 'docs/index.rst'
--- docs/index.rst	2011-06-01 23:46:19 +0000
+++ docs/index.rst	2011-06-08 03:02:27 +0000
@@ -134,6 +134,7 @@
    testing/test-run.rst
    testing/dbqp.rst
    testing/randgen.rst
+   testing/sql-bench.rst
    testing/sysbench.rst
    testing/writing_tests.rst
 

=== added file 'docs/testing/sql-bench.rst'
--- docs/testing/sql-bench.rst	1970-01-01 00:00:00 +0000
+++ docs/testing/sql-bench.rst	2011-06-08 03:02:27 +0000
@@ -0,0 +1,129 @@
+**********************************
+sql-bench
+**********************************
+
+
+
+Description
+===========
+dbqp's sql-bench mode allows a user to run the sql-bench testing suite. 
+
+
+Requirements
+============
+DBD::drizzle
+-------------
+The DBD::drizzle module is required it can be found here http://launchpad.net/dbd-drizzle/
+
+Additional information for installing the module::
+
+    Prerequisites
+    ----------------
+    * Perl
+    * Drizzle (bzr branch lp:drizzle)
+    * libdrizzle (bzr branch lp:libdrizzle)
+    * C compiler
+
+    Installation
+    -------------
+    You should only have to run the following:
+
+    perl Makefile.PL --cflags=-I/usr/local/drizzle/include/ --libs=-"L/usr/local/drizzle/lib -ldrizzle"
+
+
+    Depending on where libdrizzle is installed. Also, you'll want to make 
+    sure that ldconfig has configured libdrizzle to be in your library path 
+
+
+sql-bench / dbqp tests
+=====================
+
+Currently, there are only two sql-bench test cases for dbqp.  As one might expect, main.all_sqlbench_tests executes::
+
+    run-all-tests --server=drizzle --dir=$DRIZZLE_TEST_WORKDIR --log --connect-options=port=$MASTER_MYPORT --create-options=ENGINE=innodb --user=root 
+
+against a Drizzle server.  The second test case executes the crashme tool against a running server.
+
+Test cases are defined in python .cnf files and live in tests/sqlbench_tests.
+
+Running tests
+=========================
+
+NOTE:  all_sqlbench_tests can take a significant amount of time to execute (45 minutes or so on a decently provisioned laptop)
+
+There are several different ways to run tests using :doc:`dbqp` 's sql-bench mode.
+
+It should be noted that unless :option:`--force` is used, the program will
+stop execution upon encountering the first failing test. 
+:option:`--force` is recommended if you are running several tests - it will
+allow you to view all successes and failures in one run.
+
+Running individual tests
+------------------------
+If one only wants to run a few, specific tests, they may do so this way::
+
+    ./dbqp --mode=sql-bench [OPTIONS] test1 [test2 ... testN]
+
+Running all tests within a suite
+--------------------------------
+Many of the tests supplied with Drizzle are organized into suites.  
+
+The tests within drizzle/tests/randgen_tests/main are considered the 'main' suite.  
+Other suites are also subdirectories of drizzle/tests/randgen_tests.
+
+To run the tests in a specific suite::
+
+    ./dbqp --mode=sql-bench [OPTIONS] --suite=SUITENAME
+
+Running specific tests within a suite
+--------------------------------------
+To run a specific set of tests within a suite::
+
+    ./dbqp --mode=sql-bench [OPTIONS] --suite=SUITENAME TEST1 [TEST2..TESTN]
+
+Calling tests using <suitename>.<testname> currently does not work.
+One must specify the test suite via the :option:`--suite` option.
+
+
+Running all available tests
+---------------------------
+One would currently have to name all suites, but the majority of the working tests live in the main suite
+Other suites utilize more exotic server combinations and we are currently tweaking them to better integrate with the 
+dbqp system.  The slave-plugin suite does currently have a good config file for setting up simple replication setups for testing.
+To execute several suites' worth of tests::
+
+    ./dbqp --mode=sql-bench [OPTIONS] --suite=SUITE1, SUITE2, ...SUITEN
+
+Interpreting test results
+=========================
+The output of the test runner is quite simple.  Every test should pass.
+In the event of a test failure, please take the time to file a bug here:
+*https://bugs.launchpad.net/drizzle*
+
+During a run, the program will provide the user with:
+  * test name (suite + name)
+  * test status (pass/fail/skipped)
+  * time spent executing each test
+
+Example output::
+
+    20110601-191706  ===============================================================
+    20110601-191706  TEST NAME                                  [ RESULT ] TIME (ms)
+    20110601-191706  ===============================================================
+    20110601-191706  readonly.concurrency_16                    [ pass ]   240019
+    20110601-191706  max_req_lat_ms: 21.44
+    20110601-191706  rwreqps: 4208.2
+    20110601-191706  min_req_lat_ms: 6.31
+    20110601-191706  deadlocksps: 0.0
+    20110601-191706  tps: 150.29
+    20110601-191706  avg_req_lat_ms: 6.65
+    20110601-191706  95p_req_lat_ms: 7.02
+    20110601-191706  ===============================================================
+    20110601-191706 INFO Test execution complete in 275 seconds
+    20110601-191706 INFO Summary report:
+    20110601-191706 INFO Executed 1/1 test cases, 100.00 percent
+    20110601-191706 INFO STATUS: PASS, 1/1 test cases, 100.00 percent executed
+    20110601-191706 INFO Spent 240 / 275 seconds on: TEST(s)
+    20110601-191706 INFO Test execution complete
+    20110601-191706 INFO Stopping all running servers...
+

=== added directory 'tests/crashme_tests'
=== added directory 'tests/crashme_tests/main'
=== added file 'tests/crashme_tests/main/crashme.cnf'
--- tests/crashme_tests/main/crashme.cnf	1970-01-01 00:00:00 +0000
+++ tests/crashme_tests/main/crashme.cnf	2011-06-08 03:02:27 +0000
@@ -0,0 +1,8 @@
+[test_info]
+comment = Run all sql-bench tests!
+
+[test_command]
+command = $DRIZZLE_TEST_DIR/sql-bench/crash-me --server=drizzled --force --dir=$DRIZZLE_TEST_WORKDIR  --connect-options=port=$MASTER_MYPORT --verbose --debug --user=root
+
+[test_servers]
+servers = [[]]

=== modified file 'tests/include.am'
--- tests/include.am	2011-05-20 21:45:26 +0000
+++ tests/include.am	2011-06-08 03:02:27 +0000
@@ -62,6 +62,9 @@
 	${srcdir}/tests/dbqp.py \
 	${srcdir}/tests/dbqp_data \
 	${srcdir}/tests/randgen_tests \
+	${srcdir}/tests/sql-bench \
+	${srcdir}/tests/sqlbench_tests \
+	${srcdir}/tetss/sysbench_tests \
 	${srcdir}/tests/README.stress \
 	${srcdir}/tests/suite \
 	${srcdir}/tests/t \
@@ -78,6 +81,8 @@
 	${srcdir}/tests/lib/My/*.pm \
 	${srcdir}/tests/lib/randgen/*.py \
         ${srcdir}/tests/lib/server_mgmt/*py \
+	${srcdir}/tests/lib/sqlbench/*py \
+	${srcdir}/tests/lib/sysbench/*py \
 	${srcdir}/tests/lib/sys_mgmt/*py \
 	${srcdir}/tests/lib/test_mgmt/*py \
 	tests/strip-valgrind

=== modified file 'tests/lib/sqlbench/sqlbench_test_execution.py'
--- tests/lib/sqlbench/sqlbench_test_execution.py	2011-06-07 18:45:15 +0000
+++ tests/lib/sqlbench/sqlbench_test_execution.py	2011-06-08 03:02:27 +0000
@@ -36,6 +36,8 @@
 
 import lib.test_mgmt.test_execution as test_execution
 
+
+
 class sqlbenchTestExecutor(test_execution.testExecutor):
     """ sqlbench-specific testExecutor 
         
@@ -95,8 +97,20 @@
 
     def process_sqlbench_output(self):
         
-                    
-        if self.current_test_retcode == 0:
+        # Check for 'Failed' in sql-bench output
+        # The tests don't die on a failed test and
+        # require some checking of the output file
+        infile_name = self.current_test_output.split('\n')[1].strip()
+        inf= open(infile_name, "r")
+        inlines= inf.readlines()
+        error_flag= False
+        for inline in inlines:
+            if 'Failed' in inline:
+                error_flag= True
+                logging.info(inline.strip())
+        inf.close()                    
+        self.current_test_output += ''.join(inlines)
+        if self.current_test_retcode == 0 and not error_flag:
             return 'pass'
         else:
             return 'fail'
@@ -163,6 +177,106 @@
         self.system_manager.create_symlinks(needed_symlinks)
 
     
-   
+class crashmeTestExecutor(sqlbenchTestExecutor):
+    """ crashme-specific variant of sqlbench executor """
+
+    def execute_testCase (self):
+        """ Execute a crashme testCase
+
+        """
+        test_execution.testExecutor.execute_testCase(self)
+        self.status = 0
+
+        self.prepare_config()
+
+        # execute sqlbench
+        self.execute_crashme()
+
+        # analyze results
+        self.current_test_status = self.process_crashme_output()
+        self.set_server_status(self.current_test_status)
+        self.server_manager.reset_servers(self.name)
+
+    def prepare_config(self):
+        """ Create the config file crash-me needs to execute """
+
+        output_filename= "%s/drizzle.cfg" % (self.system_manager.workdir)
+
+        # remove the existing configuration file to start fresh
+        if os.path.exists(output_filename):
+            logging.info("Removing %s" % output_filename)
+            os.remove(output_filename)
+  
+        output_file= open(output_filename,"w")
+        # don't support '+' for concatenation
+        output_file.writelines("func_extra_concat_as_+=no\n")
+        # new boost libraries are causing us to put these limits in, needs investigation
+        output_file.writelines("max_text_size=1048576\n")
+        output_file.writelines("where_string_size=1048576\n")
+        output_file.writelines("select_string_size=1048576\n")
+        output_file.flush()
+        output_file.close()
+
+    def execute_crashme(self):
+        """ Execute the commandline and return the result.
+            We use subprocess as we can pass os.environ dicts and whatnot 
+
+        """
+
+        output_filename= "%s/drizzle.cfg" % (self.system_manager.workdir)      
+        testcase_name = self.current_testcase.fullname
+        self.time_manager.start(testcase_name,'test')
+        crashme_outfile = os.path.join(self.logdir,'crashme.out')
+        crashme_output = open(crashme_outfile,'w')
+        crashme_cmd = self.current_testcase.test_command + " --config-file=%s" %(output_filename)
+        self.logging.info("Executing crash-me:  %s" %(crashme_cmd))
+        
+        crashme_subproc = subprocess.Popen( crashme_cmd
+                                         , shell=True
+                                         , cwd=os.path.join(self.system_manager.testdir, 'sql-bench')
+                                         , env=self.working_environment
+                                         , stdout = crashme_output
+                                         , stderr = subprocess.STDOUT
+                                         )
+        crashme_subproc.wait()
+        retcode = crashme_subproc.returncode     
+        execution_time = int(self.time_manager.stop(testcase_name)*1000) # millisec
+
+        crashme_output.close()
+        crashme_file = open(crashme_outfile,'r')
+        output = ''.join(crashme_file.readlines())
+        if self.debug:
+            self.logging.debug(output)
+        crashme_file.close()
+
+        if self.debug:
+            self.logging.debug("crashme_retcode: %d" %(retcode))
+        self.current_test_retcode = retcode
+        self.current_test_output = output
+        self.current_test_exec_time = execution_time
+
+    def process_crashme_output(self):
+        infile_name = self.current_test_output.split('\n')[3].split(':')[1].strip()
+        inf= open(infile_name, "r")
+        inlines= inf.readlines()
+        error_flag= False
+        in_error_section = False
+        # crash-me is quite chatty and we don't normally want to sift
+        # through ALL of that stuff.  We do allow seeing it via --verbose
+        if not self.verbose:
+            self.current_test_output = ''
+        for inline in inlines:
+            if in_error_section and not inline.strip().startswith('#'):
+                in_error_section = False
+            if '=error' in inline:
+                error_flag= True
+                in_error_section= True
+            if in_error_section:
+                self.current_test_output += inline
+        inf.close()                
+        if self.current_test_retcode == 0 and not error_flag:
+            return 'pass'
+        else:
+            return 'fail'
 
         

=== modified file 'tests/lib/sqlbench/sqlbench_test_management.py'
--- tests/lib/sqlbench/sqlbench_test_management.py	2011-06-07 18:45:15 +0000
+++ tests/lib/sqlbench/sqlbench_test_management.py	2011-06-08 03:02:27 +0000
@@ -43,13 +43,14 @@
     def __init__( self, system_manager, name=None
                 , fullname = None, server_requirements=[[]]
                 , comment=None, test_command=None, cnf_path=None
+                , suitename = 'sqlbench_tests'
                 , debug=False ):
         self.system_manager = system_manager
         self.logging = self.system_manager.logging
         self.skip_keys = ['system_manager','logging']
         self.name = name
         self.fullname = fullname
-        self.suitename = 'sqlbench_tests'
+        self.suitename = suitename
         self.master_sh = None
         self.comment = comment
         self.server_requirements = server_requirements
@@ -163,3 +164,37 @@
         self.logging.test_report( test_case.fullname, test_status
                                 , str(exec_time), output
                                 , report_output= True)
+
+class crashmeTestManager(testManager):
+    """Deals with scanning test directories, gathering test cases, and 
+       collecting per-test information (opt files, etc) for use by the
+       test-runner
+
+    """
+
+    def __init__(self, verbose, debug, default_engine, dotest, skiptest
+                , reorder, suitelist, suitepaths, system_manager
+                , test_cases, mode):
+        super(testManager, self).__init__( verbose, debug, default_engine
+                                         , dotest, skiptest, reorder
+                                         , suitelist, suitepaths
+                                         , system_manager, test_cases, mode)
+        self.suitepaths = [os.path.join(self.testdir,'crashme_tests')]
+        if suitelist is None:
+            self.suitelist = ['main']
+        else:
+            self.suitelist = suitelist
+
+    def record_test_result(self, test_case, test_status, output, exec_time):
+        """ Accept the results of an executed testCase for further
+            processing.
+ 
+        """
+        if test_status not in self.executed_tests:
+            self.executed_tests[test_status] = [test_case]
+        else:
+            self.executed_tests[test_status].append(test_case)
+        # report
+        self.logging.test_report( test_case.fullname, test_status
+                                , str(exec_time), output
+                                , report_output= True)

=== modified file 'tests/lib/test_mode.py'
--- tests/lib/test_mode.py	2011-06-07 18:45:15 +0000
+++ tests/lib/test_mode.py	2011-06-08 03:02:27 +0000
@@ -64,13 +64,19 @@
         from sysbench.sysbench_test_execution import sysbenchTestExecutor as testExecutor
 
     elif test_mode == 'sqlbench':
-        # sqlbench mode - we have a standard server setup 
-        # and a variety of concurrencies we want to run
+        # sqlbench mode - we execute all test sql-bench tests
+        # - run-all-tests
 
         # get manager and executor
         from sqlbench.sqlbench_test_management import testManager
         from sqlbench.sqlbench_test_execution import sqlbenchTestExecutor as testExecutor
 
+    elif test_mode == 'crashme':
+        # crashme mode - see if the server lives : )
+        # get manager and executor
+        from sqlbench.sqlbench_test_management import crashmeTestManager as testManager
+        from sqlbench.sqlbench_test_execution import crashmeTestExecutor as testExecutor
+
     elif test_mode == 'cleanup':
         # cleanup mode - we try to kill any servers whose pid's we detect
         # in our workdir.  Might extend to other things (file cleanup, etc)

=== modified file 'tests/sql-bench/crash-me' (properties changed: -x to +x)
=== removed directory 'tests/sqlbench_tests/crashme'
